/*
 * Copyright (c) 2001, Gary R. Van Sickle.
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     A copy of the GNU General Public License can be found at
 *     http://www.gnu.org/
 *
 * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
 *
 */

// This is the implementation of the ChooserPage class.  Pretty much all this does right
// now is pop up the choose dialog in choose.h/choose.cc at the right time.

#include <process.h>

#include "win32.h"
#include "resource.h"
#include "dialog.h"

#include "chooser.h"
#include "propsheet.h"
#include "threebar.h"
extern ThreeBarProgressPage Progress;

#define WM_APP_START_CHOOSE        WM_APP+0
#define WM_APP_CHOOSE_IS_FINISHED  WM_APP+1

extern void
do_choose (HINSTANCE h, HWND owner);

void do_choose_thread(void *p)
{
	ChooserPage *cp;

	cp = static_cast<ChooserPage*>(p);

	do_choose(cp->GetInstance(), cp->GetHWND());

	cp->PostMessage(WM_APP_CHOOSE_IS_FINISHED);

	_endthread();
}

bool ChooserPage::Create()
{
  return PropertyPage::Create(IDD_CHOOSER);
}

void ChooserPage::OnActivate()
{
  GetOwner()->SetButtons(0);
  PostMessage(WM_APP_START_CHOOSE);
}

bool ChooserPage::OnMessageApp(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_APP_START_CHOOSE:
		{
			// Start the chooser thread.
			_beginthread(do_choose_thread, 0, this);
			break;
		}
	case WM_APP_CHOOSE_IS_FINISHED:
		{
			if(next_dialog == 0)
			{
				// Cancel
				GetOwner()->PressButton(PSBTN_CANCEL);
				break;
			}
			Progress.SetActivateTask(WM_APP_START_DOWNLOAD);
			GetOwner()->SetActivePageByID(IDD_INSTATUS);
			break;
		}
	default:
		return false;
		break;
	}
	return true;
}
